StopBlockBug = {}
local sbb = StopBlockBug

-- Written by M0R_Gaming, adapted from Andy.s' Lock Weapon Swap addon

sbb.name = "NoM0RBlockBug"
sbb.locked = false
local cooldown = 500
local sheathed = true

-- run every 250ms
-- Check if weapons are sheathed
-- if they are, disallow barswaps for .5 seconds
function sbb.checkBars()
	sheathed = ArePlayerWeaponsSheathed()
	if sheathed then
		if not sbb.locked then
			sbb.locked = true
			cooldown = 0
			sbb.Lock()
		end
	else
		if sbb.locked then
			if cooldown == 0 then
				cooldown = 500
			else
				cooldown = cooldown - 250
				if cooldown <= 0 then
					sbb.locked = false
					sbb.Unlock()
				end
			end
		end
	end
end



-- The following was adapted from Andy.s's Lock Weapon Swap addon

local locked = false
function sbb.IsLocked(reason)
	return locked
end

-- Lock weapon swap.
function sbb.Lock()
	locked = true
	-- Visuals
	ZO_WeaponSwap_SetExternallyLocked(ZO_ActionBar1WeaponSwap, true)
	if FAB_ActionBarArrow then -- fancy action bar
		FAB_ActionBarArrow:SetDesaturation(1)
	end
end

-- Unlock weapon swap.
function sbb.Unlock()
	locked = false
	-- Visuals
	ZO_WeaponSwap_SetExternallyLocked(ZO_ActionBar1WeaponSwap, false)
	if FAB_ActionBarArrow then -- fancy action bar
		FAB_ActionBarArrow:SetDesaturation(0)
	end
end








function sbb.OnAddOnLoaded(event, addonName)
	if addonName ~= sbb.name then return end
	sbb:Initialize()
end

function sbb:Initialize()
	EVENT_MANAGER:UnregisterForEvent(sbb.name, EVENT_ADD_ON_LOADED)

	-- The following was adapted from Andy.s's Lock Weapon Swap addon
	ZO_PreHook(ACTION_BAR_ASSIGNMENT_MANAGER, 'CanCycleHotbars', function() return sbb.IsLocked() end)
	local IsShowing = SKILLS_FRAGMENT.IsShowing
	SKILLS_FRAGMENT.IsShowing = function(self) return true and sbb.IsLocked() or IsShowing(self) end


	EVENT_MANAGER:RegisterForUpdate("StopBlockBugBarCheck", 250, sbb.checkBars)
end

EVENT_MANAGER:RegisterForEvent(sbb.name, EVENT_ADD_ON_LOADED, sbb.OnAddOnLoaded)